//+------------------------------------------------------------------+
//|                                             EMA+AMA+ADX+MASD.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property show_inputs
extern int MaxRisk=2;
extern int TakeProfit=100;
extern int StopLoss=100;
extern int MA1_Period=3;
extern int MA2_period=18;
extern int RSI_Period=14;

int 
   Usl_1a=0, 
   Usl_2a=0, 
   Usl_1b=0, 
   Usl_2b=0, 
   Usl_1c=0, 
   Usl_2c=0, 
   Usl_0=0, 
   Order=0;
double
   RSI,                             //  RSI  0 
   M_0,                            //  MACD  0 
   MA1_0, MA2_0,                   //  EMA  3  18  0 
   MA1_1, MA2_1;                   //  EMA  3  18  1 



//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   if(DayOfWeek()==0||DayOfWeek()==6)return(0);//    
   if(!IsTradeAllowed())return(0);//     

//----

   double Lot=GetLot(MaxRisk);
   M_0=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,0);    //0 
   RSI=iRSI(NULL,0,RSI_Period,PRICE_CLOSE,0);            //0 
   MA1_0=iMA(NULL,0,MA1_Period,0,MODE_EMA,PRICE_CLOSE,0);//0 
   MA1_1=iMA(NULL,0,MA1_Period,0,MODE_EMA,PRICE_CLOSE,1);//1 
   MA2_0=iMA(NULL,0,MA2_period,0,MODE_EMA,PRICE_CLOSE,0);//0 
   MA2_1=iMA(NULL,0,MA2_period,0,MODE_EMA,PRICE_CLOSE,1);//1 
   
//--------------------------------------------------------------

   if(Order==1)
     {
     if(MA1_1>MA2_1 && MA1_0<MA2_0)
        {
        CloseOrder(); Order=0; Usl_0=0; Usl_1a=0; Usl_1b=0; Usl_1c=0;
        }
     else 
        Usl_0=1;
     }
   if(Order==-1)
     {
     if(MA1_1<MA2_1 && MA1_0>MA2_0)
        {
        CloseOrder(); Order=0; Usl_0=0; Usl_2a=0; Usl_2b=0; Usl_2c=0;
        }
     else 
        Usl_0=1;
     }
     
   if(Usl_0==1)
      return(0);
   else
   {  
//--------------------------------------------------------------   
    
   if(MA1_1<MA2_1 && MA1_0>MA2_0)  Usl_1a=1;
   if(MA1_1>MA2_1 && MA1_0<MA2_0)  Usl_2a=1;
   
//-------------------------------------------------------------- 
  
   if(Usl_1a==1)
     {
     if(M_0>0) Usl_1b=1;
     }
   if(Usl_2a==1)
     {
     if(M_0<0) Usl_2b=1;
     }  
     
//--------------------------------------------------------------    

   if(Usl_1b==1)
     {
     if(RSI>50) Usl_1c=1;
     }
   if(Usl_2b==1)
     {
     if(RSI<50) Usl_2c=1;
     }
//--------------------------------------------------------------   

   if(Usl_1c==1) 
     {
     NewOrder(OP_BUY,Lot); Order=1;
     }
   if(Usl_2c==1) 
     {
     NewOrder(OP_SELL,Lot); Order=-1;
     }
     
//----

   return(0);
   }
  }
//+---------  ---------------------------------------------------------+
double GetLot(int Risk)
{
 double Free=AccountFreeMargin();
 double One_Lot=MarketInfo(Symbol(),MODE_MARGINREQUIRED);
 double Min_Lot=MarketInfo(Symbol(),MODE_MINLOT);
 double Max_Lot=MarketInfo(Symbol(),MODE_MAXLOT);
 double Step=MarketInfo(Symbol(),MODE_LOTSTEP);
 double Lot=MathFloor(Free*Risk/100/One_Lot/Step)*Step;
 if(Lot<Min_Lot)Lot=Min_Lot;
 if(Lot>Max_Lot)Lot=Max_Lot;
 if(Lot*One_Lot>Free)return(0.0);
 return(Lot);
}
//+----------  ------------------------------------------------------+
int NewOrder(int Cmd,double Lot)
{
 double TP=0;// 
 double SL=0;// 
 double PR=0;// 
 while(!IsTradeAllowed())Sleep(100);
 if(Cmd==OP_BUY)
   {
    PR=Ask;
    if(TakeProfit>0)TP=Ask+TakeProfit*Point;
    if(StopLoss>0)SL=Bid-StopLoss*Point;
   }
 if(Cmd==OP_SELL)
   {
    PR=Bid;
    if(TakeProfit>0)TP=Bid-TakeProfit*Point;
    if(StopLoss>0)SL=Ask+StopLoss*Point; 
   }  
 int tic=OrderSend(Symbol(),Cmd,Lot,PR,3,SL,TP,"",0,0,CLR_NONE);
 if(tic<0)Print("  :",GetLastError());
return(tic);
}

//+-----------  ------------------------------------------------------+
void CloseOrder()
 {
 double PR=0;
 while(!IsTradeAllowed()) Sleep(100);
 if(OrderType()==OP_BUY)  PR=Bid;
 if(OrderType()==OP_SELL) PR=Ask;
 if(!OrderClose(OrderTicket(),OrderLots(),PR,3,CLR_NONE))
   Print("  : ",GetLastError());
 //-- 1. else
 //-- 1.  OrderClose(OrderTicket(),OrderLots(),PR,3,CLR_NONE);
 return;
 }